8e0ee97be15f05335a6533e946172c95d52e487a
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
202     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
203     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
204     # Directories created if not present:
205     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
206     # Functions called:
207     # - die - Print to stderr and exit.
208
209     set -exuo pipefail
210
211     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
212         die "Some error during locating of this source file."
213     }
214     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
215         die "Some error during dirname call."
216     }
217     # Current working directory could be in a different repo, e.g. VPP.
218     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
219     relative_csit_dir=$(git rev-parse --show-toplevel) || {
220         die "Git rev-parse failed."
221     }
222     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
223     popd || die "Popd failed."
224     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
225         die "Readlink failed."
226     }
227     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
228         die "Readlink failed."
229     }
230     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
231         die "Readlink failed."
232     }
233     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
234         die "Readlink failed."
235     }
236     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_pybot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # Variables set:
267     # - PYBOT_ARGS - String holding part of all arguments for pybot.
268     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
269
270     set -exuo pipefail
271
272     # No explicit check needed with "set -u".
273     PYBOT_ARGS=("--loglevel" "TRACE")
274     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
275
276     case "${TEST_CODE}" in
277         *"device"*)
278             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
279             ;;
280         *"perf"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
282             ;;
283         *)
284             die "Unknown specification: ${TEST_CODE}"
285     esac
286
287     EXPANDED_TAGS=()
288     for tag in "${TAGS[@]}"; do
289         if [[ ${tag} == "!"* ]]; then
290             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
291         else
292             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
293         fi
294     done
295 }
296
297
298 function copy_archives () {
299
300     # Create additional archive if workspace variable is set.
301     # This way if script is running in jenkins all will be
302     # automatically archived to logs.fd.io.
303     #
304     # Variables read:
305     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
306     #   Can be unset, then it speeds up manual testing.
307     # - ARCHIVE_DIR - Path to directory with content to be copied.
308     # Directories updated:
309     # - ${WORKSPACE}/archives/ - Created if does not exist.
310     #   Content of ${ARCHIVE_DIR}/ is copied here.
311     # Functions called:
312     # - die - Print to stderr and exit.
313
314     set -exuo pipefail
315
316     if [[ -n "${WORKSPACE-}" ]]; then
317         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
318         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
319     fi
320 }
321
322
323 function deactivate_docker_topology () {
324
325     # Deactivate virtual vpp-device topology by removing containers.
326     #
327     # Variables read:
328     # - NODENESS - Node multiplicity of desired testbed.
329     # - FLAVOR - Node flavor string, usually describing the processor.
330
331     set -exuo pipefail
332
333     case_text="${NODENESS}_${FLAVOR}"
334     case "${case_text}" in
335         "1n_skx" | "1n_tx2")
336             ssh="ssh root@172.17.0.1 -p 6022"
337             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
338             # The "declare -f" output is long and boring.
339             set +x
340             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
341                 die "Topology cleanup via shim-dcr failed!"
342             }
343             set -x
344             ;;
345         "1n_vbox")
346             enter_mutex || die
347             clean_environment || {
348                 die "Topology cleanup locally failed!"
349             }
350             exit_mutex || die
351             ;;
352         *)
353             die "Unknown specification: ${case_text}!"
354     esac
355 }
356
357
358 function die () {
359
360     # Print the message to standard error end exit with error code specified
361     # by the second argument.
362     #
363     # Hardcoded values:
364     # - The default error message.
365     # Arguments:
366     # - ${1} - The whole error message, be sure to quote. Optional
367     # - ${2} - the code to exit with, default: 1.
368
369     set -x
370     set +eu
371     warn "${1:-Unspecified run-time error occurred!}"
372     exit "${2:-1}"
373 }
374
375
376 function die_on_pybot_error () {
377
378     # Source this fragment if you want to abort on any failed test case.
379     #
380     # Variables read:
381     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
382     # Functions called:
383     # - die - Print to stderr and exit.
384
385     set -exuo pipefail
386
387     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
388         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
389     fi
390 }
391
392
393 function generate_tests () {
394
395     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
396     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
397     # The generation is done by executing any *.py executable
398     # within any subdirectory after copying.
399
400     # This is a separate function, because this code is called
401     # both by autogen checker and entries calling run_pybot.
402
403     # Directories read:
404     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
405     # Directories replaced:
406     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
407
408     set -exuo pipefail
409
410     rm -rf "${GENERATED_DIR}/tests" || die
411     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
412     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
413     cmd_line+=("-executable" "-name" "*.py")
414     # We sort the directories, so log output can be compared between runs.
415     file_list=$("${cmd_line[@]}" | sort) || die
416
417     for gen in ${file_list}; do
418         directory="$(dirname "${gen}")" || die
419         filename="$(basename "${gen}")" || die
420         pushd "${directory}" || die
421         ./"${filename}" || die
422         popd || die
423     done
424 }
425
426
427 function get_test_code () {
428
429     # Arguments:
430     # - ${1} - Optional, argument of entry script (or empty as unset).
431     #   Test code value to override job name from environment.
432     # Variables read:
433     # - JOB_NAME - String affecting test selection, default if not argument.
434     # Variables set:
435     # - TEST_CODE - The test selection string from environment or argument.
436     # - NODENESS - Node multiplicity of desired testbed.
437     # - FLAVOR - Node flavor string, usually describing the processor.
438
439     set -exuo pipefail
440
441     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
442     if [[ -z "${TEST_CODE}" ]]; then
443         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
444     fi
445
446     case "${TEST_CODE}" in
447         *"1n-vbox"*)
448             NODENESS="1n"
449             FLAVOR="vbox"
450             ;;
451         *"1n-skx"*)
452             NODENESS="1n"
453             FLAVOR="skx"
454             ;;
455        *"1n-tx2"*)
456             NODENESS="1n"
457             FLAVOR="tx2"
458             ;;
459         *"2n-skx"*)
460             NODENESS="2n"
461             FLAVOR="skx"
462             ;;
463         *"3n-skx"*)
464             NODENESS="3n"
465             FLAVOR="skx"
466             ;;
467         *"2n-clx"*)
468             NODENESS="2n"
469             FLAVOR="clx"
470             ;;
471         *"2n-dnv"*)
472             NODENESS="2n"
473             FLAVOR="dnv"
474             ;;
475         *"3n-dnv"*)
476             NODENESS="3n"
477             FLAVOR="dnv"
478             ;;
479         *"3n-tsh"*)
480             NODENESS="3n"
481             FLAVOR="tsh"
482             ;;
483         *)
484             # Fallback to 3-node Haswell by default (backward compatibility)
485             NODENESS="3n"
486             FLAVOR="hsw"
487             ;;
488     esac
489 }
490
491
492 function get_test_tag_string () {
493
494     # Variables read:
495     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
496     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
497     # - TEST_CODE - The test selection string from environment or argument.
498     # Variables set:
499     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
500     #   May be empty, or even not set on event types not adding comment.
501
502     # TODO: ci-management scripts no longer need to perform this.
503
504     set -exuo pipefail
505
506     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
507         case "${TEST_CODE}" in
508             *"device"*)
509                 trigger="devicetest"
510                 ;;
511             *"perf"*)
512                 trigger="perftest"
513                 ;;
514             *)
515                 die "Unknown specification: ${TEST_CODE}"
516         esac
517         # Ignore lines not containing the trigger word.
518         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}") || true
519         # The vpp-csit triggers trail stuff we are not interested in.
520         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
521         # (except relying on \s whitespace, \S non-whitespace and . both).
522         # The last string is concatenated, only the middle part is expanded.
523         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
524         # On parsing error, TEST_TAG_STRING probably stays empty.
525         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
526         if [[ -n "${TEST_TAG_STRING-}" ]]; then
527             test_tag_array=(${TEST_TAG_STRING})
528             if [[ "${test_tag_array[0]}" == "icl" ]]; then
529                 export GRAPH_NODE_VARIANT="icl"
530                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
531             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
532                 export GRAPH_NODE_VARIANT="skx"
533                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
534             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
535                 export GRAPH_NODE_VARIANT="hsw"
536                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
537             fi
538         fi
539     fi
540 }
541
542
543 function installed () {
544
545     # Check if the given utility is installed. Fail if not installed.
546     #
547     # Duplicate of common.sh function, as this file is also used standalone.
548     #
549     # Arguments:
550     # - ${1} - Utility to check.
551     # Returns:
552     # - 0 - If command is installed.
553     # - 1 - If command is not installed.
554
555     set -exuo pipefail
556
557     command -v "${1}"
558 }
559
560
561 function reserve_and_cleanup_testbed () {
562
563     # Reserve physical testbed, perform cleanup, register trap to unreserve.
564     # When cleanup fails, remove from topologies and keep retrying
565     # until all topologies are removed.
566     #
567     # Variables read:
568     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
569     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
570     # - BUILD_TAG - Any string suitable as filename, identifying
571     #   test run executing this function. May be unset.
572     # Variables set:
573     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
574     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
575     # Functions called:
576     # - die - Print to stderr and exit.
577     # - ansible_playbook - Perform an action using ansible, see ansible.sh
578     # Traps registered:
579     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
580
581     set -exuo pipefail
582
583     while true; do
584         for topo in "${TOPOLOGIES[@]}"; do
585             set +e
586             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
587             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
588             python3 "${scrpt}" "${opts[@]}"
589             result="$?"
590             set -e
591             if [[ "${result}" == "0" ]]; then
592                 # Trap unreservation before cleanup check,
593                 # so multiple jobs showing failed cleanup improve chances
594                 # of humans to notice and fix.
595                 WORKING_TOPOLOGY="${topo}"
596                 echo "Reserved: ${WORKING_TOPOLOGY}"
597                 trap "untrap_and_unreserve_testbed" EXIT || {
598                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
599                     untrap_and_unreserve_testbed "${message}" || {
600                         die "Teardown should have died, not failed."
601                     }
602                     die "Trap attempt failed, unreserve succeeded. Aborting."
603                 }
604                 # Cleanup + calibration checks.
605                 set +e
606                 ansible_playbook "cleanup, calibration"
607                 result="$?"
608                 set -e
609                 if [[ "${result}" == "0" ]]; then
610                     break
611                 fi
612                 warn "Testbed cleanup failed: ${topo}"
613                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
614             fi
615             # Else testbed is accessible but currently reserved, moving on.
616         done
617
618         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
619             # Exit the infinite while loop if we made a reservation.
620             warn "Reservation and cleanup successful."
621             break
622         fi
623
624         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
625             die "Run out of operational testbeds!"
626         fi
627
628         # Wait ~3minutes before next try.
629         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
630             die "Sleep time calculation failed."
631         }
632         echo "Sleeping ${sleep_time}"
633         sleep "${sleep_time}" || die "Sleep failed."
634     done
635 }
636
637
638 function run_pybot () {
639
640     # Run pybot with options based on input variables. Create output_info.xml
641     #
642     # Variables read:
643     # - CSIT_DIR - Path to existing root of local CSIT git repository.
644     # - ARCHIVE_DIR - Path to store robot result files in.
645     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
646     # - GENERATED_DIR - Tests are assumed to be generated under there.
647     # Variables set:
648     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
649     # Functions called:
650     # - die - Print to stderr and exit.
651
652     set -exuo pipefail
653
654     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
655     all_options+=("--noncritical" "EXPECTED_FAILING")
656     all_options+=("${EXPANDED_TAGS[@]}")
657
658     pushd "${CSIT_DIR}" || die "Change directory operation failed."
659     set +e
660     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
661     PYBOT_EXIT_STATUS="$?"
662     set -e
663
664     # Generate INFO level output_info.xml for post-processing.
665     all_options=("--loglevel" "INFO")
666     all_options+=("--log" "none")
667     all_options+=("--report" "none")
668     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
669     all_options+=("${ARCHIVE_DIR}/output.xml")
670     rebot "${all_options[@]}" || true
671     popd || die "Change directory operation failed."
672 }
673
674
675 function select_arch_os () {
676
677     # Set variables affected by local CPU architecture and operating system.
678     #
679     # Variables set:
680     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
681     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
682     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
683
684     set -exuo pipefail
685
686     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
687         die "Get OS release failed."
688     }
689
690     case "${os_id}" in
691         "ubuntu"*)
692             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
693             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
694             PKG_SUFFIX="deb"
695             ;;
696         "centos"*)
697             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
698             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
699             PKG_SUFFIX="rpm"
700             ;;
701         *)
702             die "Unable to identify distro or os from ${os_id}"
703             ;;
704     esac
705
706     arch=$(uname -m) || {
707         die "Get CPU architecture failed."
708     }
709
710     case "${arch}" in
711         "aarch64")
712             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
713             ;;
714         *)
715             ;;
716     esac
717 }
718
719
720 function select_tags () {
721
722     # Variables read:
723     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
724     # - TEST_CODE - String affecting test selection, usually jenkins job name.
725     # - DUT - CSIT test/ subdirectory, set while processing tags.
726     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
727     #   Can be unset.
728     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
729     # - BASH_FUNCTION_DIR - Directory with input files to process.
730     # Variables set:
731     # - TAGS - Array of processed tag boolean expressions.
732
733     set -exuo pipefail
734
735     # NIC SELECTION
736     start_pattern='^  TG:'
737     end_pattern='^ \? \?[A-Za-z0-9]\+:'
738     # Remove the TG section from topology file
739     sed_command="/${start_pattern}/,/${end_pattern}/d"
740     # All topologies DUT NICs
741     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
742                 | grep -hoP "model: \K.*" | sort -u)
743     # Selected topology DUT NICs
744     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
745                | grep -hoP "model: \K.*" | sort -u)
746     # All topologies DUT NICs - Selected topology DUT NICs
747     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
748         die "Computation of excluded NICs failed."
749     }
750
751     # Select default NIC tag.
752     case "${TEST_CODE}" in
753         *"3n-dnv"* | *"2n-dnv"*)
754             default_nic="nic_intel-x553"
755             ;;
756         *"3n-tsh"*)
757             default_nic="nic_intel-x520-da2"
758             ;;
759         *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
760             default_nic="nic_intel-xxv710"
761             ;;
762         *"3n-hsw"* | *"mrr-daily-master")
763             default_nic="nic_intel-xl710"
764             ;;
765         *)
766             default_nic="nic_intel-x710"
767             ;;
768     esac
769
770     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
771     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
772     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
773     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
774     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
775     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
776     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
777     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
778     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
779     # Tag file directory shorthand.
780     tfd="${JOB_SPECS_DIR}"
781     case "${TEST_CODE}" in
782         # Select specific performance tests based on jenkins job type variable.
783         *"ndrpdr-weekly"* )
784             readarray -t test_tag_array <<< $(sed 's/ //g' \
785                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
786                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
787             ;;
788         *"mrr-daily"* )
789             readarray -t test_tag_array <<< $(sed 's/ //g' \
790                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
791                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
792             ;;
793         *"mrr-weekly"* )
794             readarray -t test_tag_array <<< $(sed 's/ //g' \
795                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
796                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
797             ;;
798         *"report-iterative"* )
799             test_sets=(${TEST_TAG_STRING//:/ })
800             # Run only one test set per run
801             report_file=${test_sets[0]}.md
802             readarray -t test_tag_array <<< $(sed 's/ //g' \
803                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
804                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
805             ;;
806         *"report-coverage"* )
807             test_sets=(${TEST_TAG_STRING//:/ })
808             # Run only one test set per run
809             report_file=${test_sets[0]}.md
810             readarray -t test_tag_array <<< $(sed 's/ //g' \
811                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
812                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
813             ;;
814         * )
815             if [[ -z "${TEST_TAG_STRING-}" ]]; then
816                 # If nothing is specified, we will run pre-selected tests by
817                 # following tags.
818                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
819                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
820                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
821                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
822                                 "!dot1q" "!drv_avf")
823             else
824                 # If trigger contains tags, split them into array.
825                 test_tag_array=(${TEST_TAG_STRING//:/ })
826             fi
827             ;;
828     esac
829
830     # Blacklisting certain tags per topology.
831     #
832     # Reasons for blacklisting:
833     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
834     # TODO: Add missing reasons here (if general) or where used (if specific).
835     case "${TEST_CODE}" in
836         *"2n-skx"*)
837             test_tag_array+=("!ipsechw")
838             ;;
839         *"3n-skx"*)
840             test_tag_array+=("!ipsechw")
841             # Not enough nic_intel-xxv710 to support double link tests.
842             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
843             ;;
844         *"2n-clx"*)
845             test_tag_array+=("!ipsechw")
846             ;;
847         *"2n-dnv"*)
848             test_tag_array+=("!ipsechw")
849             test_tag_array+=("!memif")
850             test_tag_array+=("!srv6_proxy")
851             test_tag_array+=("!vhost")
852             test_tag_array+=("!vts")
853             test_tag_array+=("!drv_avf")
854             ;;
855         *"3n-dnv"*)
856             test_tag_array+=("!memif")
857             test_tag_array+=("!srv6_proxy")
858             test_tag_array+=("!vhost")
859             test_tag_array+=("!vts")
860             test_tag_array+=("!drv_avf")
861             ;;
862         *"3n-tsh"*)
863             # 3n-tsh only has x520 NICs which don't work with AVF
864             test_tag_array+=("!drv_avf")
865             test_tag_array+=("!ipsechw")
866             ;;
867         *"3n-hsw"*)
868             # TODO: Introduce NOIOMMU version of AVF tests.
869             # TODO: Make (both) AVF tests work on Haswell,
870             # or document why (some of) it is not possible.
871             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
872             test_tag_array+=("!drv_avf")
873             # All cards have access to QAT. But only one card (xl710)
874             # resides in same NUMA as QAT. Other cards must go over QPI
875             # which we do not want to even run.
876             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
877             ;;
878         *)
879             # Default to 3n-hsw due to compatibility.
880             test_tag_array+=("!drv_avf")
881             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
882             ;;
883     esac
884
885     # We will add excluded NICs.
886     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
887
888     TAGS=()
889
890     # We will prefix with perftest to prevent running other tests
891     # (e.g. Functional).
892     prefix="perftestAND"
893     set +x
894     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
895         # Automatic prefixing for VPP jobs to limit the NIC used and
896         # traffic evaluation to MRR.
897         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
898             prefix="${prefix}mrrAND"
899         else
900             prefix="${prefix}mrrAND${default_nic}AND"
901         fi
902     fi
903     for tag in "${test_tag_array[@]}"; do
904         if [[ "${tag}" == "!"* ]]; then
905             # Exclude tags are not prefixed.
906             TAGS+=("${tag}")
907         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
908             # Badly formed tag expressions can trigger way too much tests.
909             set -x
910             warn "The following tag expression hints at bad trigger: ${tag}"
911             warn "Possible cause: Multiple triggers in a single comment."
912             die "Aborting to avoid triggering too many tests."
913         elif [[ "${tag}" == *"OR"* ]]; then
914             # If OR had higher precedence than AND, it would be useful here.
915             # Some people think it does, thus triggering way too much tests.
916             set -x
917             warn "The following tag expression hints at bad trigger: ${tag}"
918             warn "Operator OR has lower precedence than AND. Use space instead."
919             die "Aborting to avoid triggering too many tests."
920         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
921             # Empty and comment lines are skipped.
922             # Other lines are normal tags, they are to be prefixed.
923             TAGS+=("${prefix}${tag}")
924         fi
925     done
926     set -x
927 }
928
929
930 function select_topology () {
931
932     # Variables read:
933     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
934     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
935     # - CSIT_DIR - Path to existing root of local CSIT git repository.
936     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
937     # Variables set:
938     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
939     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
940     # Functions called:
941     # - die - Print to stderr and exit.
942
943     set -exuo pipefail
944
945     case_text="${NODENESS}_${FLAVOR}"
946     case "${case_text}" in
947         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
948         # TODO: Double link availability depends on NIC used.
949         "1n_vbox")
950             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
951             TOPOLOGIES_TAGS="2_node_single_link_topo"
952             ;;
953         "1n_skx" | "1n_tx2")
954             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
955             TOPOLOGIES_TAGS="2_node_single_link_topo"
956             ;;
957         "2n_skx")
958             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
959             TOPOLOGIES_TAGS="2_node_*_link_topo"
960             ;;
961         "3n_skx")
962             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
963             TOPOLOGIES_TAGS="3_node_*_link_topo"
964             ;;
965         "2n_clx")
966             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
967             TOPOLOGIES_TAGS="2_node_*_link_topo"
968             ;;
969         "2n_dnv")
970             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
971             TOPOLOGIES_TAGS="2_node_single_link_topo"
972             ;;
973         "3n_dnv")
974             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
975             TOPOLOGIES_TAGS="3_node_single_link_topo"
976             ;;
977         "3n_hsw")
978             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
979             TOPOLOGIES_TAGS="3_node_single_link_topo"
980             ;;
981         "3n_tsh")
982             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
983             TOPOLOGIES_TAGS="3_node_single_link_topo"
984             ;;
985         *)
986             # No falling back to 3n_hsw default, that should have been done
987             # by the function which has set NODENESS and FLAVOR.
988             die "Unknown specification: ${case_text}"
989     esac
990
991     if [[ -z "${TOPOLOGIES-}" ]]; then
992         die "No applicable topology found!"
993     fi
994 }
995
996
997 function select_vpp_device_tags () {
998
999     # Variables read:
1000     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1001     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1002     #   Can be unset.
1003     # Variables set:
1004     # - TAGS - Array of processed tag boolean expressions.
1005
1006     set -exuo pipefail
1007
1008     case "${TEST_CODE}" in
1009         # Select specific device tests based on jenkins job type variable.
1010         * )
1011             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1012                 # If nothing is specified, we will run pre-selected tests by
1013                 # following tags. Items of array will be concatenated by OR
1014                 # in Robot Framework.
1015                 test_tag_array=()
1016             else
1017                 # If trigger contains tags, split them into array.
1018                 test_tag_array=(${TEST_TAG_STRING//:/ })
1019             fi
1020             ;;
1021     esac
1022
1023     # Blacklisting certain tags per topology.
1024     #
1025     # Reasons for blacklisting:
1026     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1027     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1028     case "${TEST_CODE}" in
1029         *"1n-vbox"*)
1030             test_tag_array+=("!avf")
1031             test_tag_array+=("!vhost")
1032             ;;
1033         *)
1034             ;;
1035     esac
1036
1037     TAGS=()
1038
1039     # We will prefix with devicetest to prevent running other tests
1040     # (e.g. Functional).
1041     prefix="devicetestAND"
1042     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1043         # Automatic prefixing for VPP jobs to limit testing.
1044         prefix="${prefix}"
1045     fi
1046     for tag in "${test_tag_array[@]}"; do
1047         if [[ ${tag} == "!"* ]]; then
1048             # Exclude tags are not prefixed.
1049             TAGS+=("${tag}")
1050         else
1051             TAGS+=("${prefix}${tag}")
1052         fi
1053     done
1054 }
1055
1056 function untrap_and_unreserve_testbed () {
1057
1058     # Use this as a trap function to ensure testbed does not remain reserved.
1059     # Perhaps call directly before script exit, to free testbed for other jobs.
1060     # This function is smart enough to avoid multiple unreservations (so safe).
1061     # Topo cleanup is executed (call it best practice), ignoring failures.
1062     #
1063     # Hardcoded values:
1064     # - default message to die with if testbed might remain reserved.
1065     # Arguments:
1066     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1067     # Variables read (by inner function):
1068     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1069     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1070     # Variables written:
1071     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1072     # Trap unregistered:
1073     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1074     # Functions called:
1075     # - die - Print to stderr and exit.
1076     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1077
1078     set -xo pipefail
1079     set +eu  # We do not want to exit early in a "teardown" function.
1080     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1081     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1082     if [[ -z "${wt-}" ]]; then
1083         set -eu
1084         warn "Testbed looks unreserved already. Trap removal failed before?"
1085     else
1086         ansible_playbook "cleanup" || true
1087         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1088             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1089         }
1090         WORKING_TOPOLOGY=""
1091         set -eu
1092     fi
1093 }
1094
1095
1096 function warn () {
1097
1098     # Print the message to standard error.
1099     #
1100     # Arguments:
1101     # - ${@} - The text of the message.
1102
1103     set -exuo pipefail
1104
1105     echo "$@" >&2
1106 }